* [PATCH v2 1/3] fstests: btrfs: Add basic test for btrfs in-band de-duplication
2017-03-16 9:08 [PATCH v2 0/3] Btrfs in-band de-duplication test cases Qu Wenruo
@ 2017-03-16 9:08 ` Qu Wenruo
2017-03-16 9:08 ` [PATCH v2 2/3] fstests: btrfs: Add testcase for btrfs dedupe and metadata balance race test Qu Wenruo
` (2 subsequent siblings)
3 siblings, 0 replies; 9+ messages in thread
From: Qu Wenruo @ 2017-03-16 9:08 UTC (permalink / raw)
To: linux-btrfs; +Cc: fstests
Add basic test for btrfs in-band de-duplication(inmemory backend), including:
1) Enable
3) Dedup rate
4) File correctness
5) Disable
Signed-off-by: Qu Wenruo <quwenruo@cn.fujitsu.com>
---
common/defrag | 14 +++++++
tests/btrfs/200 | 110 ++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/btrfs/200.out | 22 +++++++++++
tests/btrfs/group | 1 +
4 files changed, 147 insertions(+)
create mode 100755 tests/btrfs/200
create mode 100644 tests/btrfs/200.out
diff --git a/common/defrag b/common/defrag
index d279382..62b279c 100644
--- a/common/defrag
+++ b/common/defrag
@@ -59,6 +59,20 @@ _extent_count()
$XFS_IO_PROG -c "fiemap" $1 | tail -n +2 | grep -v hole | wc -l| $AWK_PROG '{print $1}'
}
+# Get the number of unique file extents
+# Unique file extents means they have different ondisk bytenr
+# Some filesystem supports reflinkat() or in-band de-dup can create
+# a file whose all file extents points to the same ondisk bytenr
+# this can be used to test if such reflinkat() or in-band de-dup works
+_extent_count_uniq()
+{
+ local file=$1
+
+ $XFS_IO_PROG -c "fiemap" $file >> $seqres.full 2>&1
+ $XFS_IO_PROG -c "fiemap" $file | tail -n +2 | grep -v hole |\
+ $AWK_PROG '{print $3}' | sort | uniq | wc -l
+}
+
_check_extent_count()
{
min=$1
diff --git a/tests/btrfs/200 b/tests/btrfs/200
new file mode 100755
index 0000000..a23328c
--- /dev/null
+++ b/tests/btrfs/200
@@ -0,0 +1,110 @@
+#! /bin/bash
+# FS QA Test 200
+#
+# Basic btrfs inband dedupe test for inmemory backend
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Fujitsu. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/defrag
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+_require_btrfs_command dedupe
+_require_btrfs_fs_feature dedupe
+
+# File size is twice the maximum file extent of btrfs
+# So even fallbacked to non-dedupe, it will have at least 2 extents
+file_size=256m
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+
+do_dedupe_test()
+{
+ dedupe_bs=$1
+
+ echo "Testing inmemory dedupe backend with block size $dedupe_bs"
+ _run_btrfs_util_prog dedupe enable -f -s inmemory -b $dedupe_bs \
+ $SCRATCH_MNT
+ # do sync write to ensure dedupe hash is added into dedupe pool
+ $XFS_IO_PROG -f -c "pwrite -b $dedupe_bs 0 $dedupe_bs" -c "fsync"\
+ $SCRATCH_MNT/initial_block | _filter_xfs_io
+
+ # do sync write to ensure we can get stable fiemap later
+ $XFS_IO_PROG -f -c "pwrite -b $dedupe_bs 0 $file_size" -c "fsync"\
+ $SCRATCH_MNT/real_file | _filter_xfs_io
+
+ # Test if real_file is de-duplicated
+ nr_uniq_extents=$(_extent_count_uniq $SCRATCH_MNT/real_file)
+ nr_total_extents=$(_extent_count $SCRATCH_MNT/real_file)
+ nr_deduped_extents=$(($nr_total_extents - $nr_uniq_extents))
+
+ echo "deduped/total: $nr_deduped_extents/$nr_total_extents" \
+ >> $seqres.full
+ # Allow a small amount of dedupe miss, as commit interval or
+ # memory pressure may break a dedupe_bs block and cause
+ # small extent which won't go through dedupe routine
+ _within_tolerance "number of deduped extents" $nr_deduped_extents \
+ $nr_total_extents 5% -v
+
+ # Also check the md5sum to ensure data is not corrupted
+ md5=$(_md5_checksum $SCRATCH_MNT/real_file)
+ echo "md5sum: $md5"
+}
+
+# Test inmemory dedupe first, use 64K dedupe bs to keep compatibility
+# with 64K page size
+do_dedupe_test 64K
+
+# Test 128K(default) dedupe bs
+do_dedupe_test 128K
+
+# Test 1M dedupe bs
+do_dedupe_test 1M
+
+# Check dedupe disable
+_run_btrfs_util_prog dedupe disable $SCRATCH_MNT
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/200.out b/tests/btrfs/200.out
new file mode 100644
index 0000000..e09e573
--- /dev/null
+++ b/tests/btrfs/200.out
@@ -0,0 +1,22 @@
+QA output created by 200
+Testing inmemory dedupe backend with block size 64K
+wrote 65536/65536 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 268435456/268435456 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+number of deduped extents is in range
+md5sum: a30e0f3f1b0884081de11d4357811c2e
+Testing inmemory dedupe backend with block size 128K
+wrote 131072/131072 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 268435456/268435456 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+number of deduped extents is in range
+md5sum: a30e0f3f1b0884081de11d4357811c2e
+Testing inmemory dedupe backend with block size 1M
+wrote 1048576/1048576 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+wrote 268435456/268435456 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+number of deduped extents is in range
+md5sum: a30e0f3f1b0884081de11d4357811c2e
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 76a1181..4e49564 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -141,3 +141,4 @@
136 auto convert
137 auto quick send
138 auto compress
+200 auto ib-dedupe
--
2.9.3
^ permalink raw reply related [flat|nested] 9+ messages in thread* [PATCH v2 2/3] fstests: btrfs: Add testcase for btrfs dedupe and metadata balance race test
2017-03-16 9:08 [PATCH v2 0/3] Btrfs in-band de-duplication test cases Qu Wenruo
2017-03-16 9:08 ` [PATCH v2 1/3] fstests: btrfs: Add basic test for btrfs in-band de-duplication Qu Wenruo
@ 2017-03-16 9:08 ` Qu Wenruo
2017-03-16 9:08 ` [PATCH v2 3/3] fstests: btrfs: Test inband dedupe with data balance Qu Wenruo
2017-03-21 4:51 ` [PATCH v2 0/3] Btrfs in-band de-duplication test cases Eryu Guan
3 siblings, 0 replies; 9+ messages in thread
From: Qu Wenruo @ 2017-03-16 9:08 UTC (permalink / raw)
To: linux-btrfs; +Cc: fstests
Btrfs balance with inband dedupe enable/disable will expose a lot of
hidden dedupe bug:
1) Enable/disable race bug
2) Btrfs dedupe tree balance corrupted delayed_ref
3) Btrfs disable and balance will cause balance BUG_ON
Reported-by: Satoru Takeuchi <takeuchi_satoru@jp.fujitsu.com>
Signed-off-by: Qu Wenruo <quwenruo@cn.fujitsu.com>
---
tests/btrfs/201 | 113 ++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/btrfs/201.out | 2 +
tests/btrfs/group | 1 +
3 files changed, 116 insertions(+)
create mode 100755 tests/btrfs/201
create mode 100644 tests/btrfs/201.out
diff --git a/tests/btrfs/201 b/tests/btrfs/201
new file mode 100755
index 0000000..c5f6f23
--- /dev/null
+++ b/tests/btrfs/201
@@ -0,0 +1,113 @@
+#! /bin/bash
+# FS QA Test 201
+#
+# Btrfs inband dedup enable/disable race with metadata balance
+#
+# This tests will test the following bugs exposed in development:
+# 1) enable/disable race
+# 2) tree balance cause delayed ref corruption
+# 3) disable and balance cause BUG_ON
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Fujitsu. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+ $KILLALL_PROG $FSSTRESS_PROG &> /dev/null
+ kill $trigger_pid &> /dev/null
+ kill $balance_pid &> /dev/null
+ wait
+
+ # See comment later
+ $BTRFS_UTIL_PROG balance cancel $SCRATCH_MNT &> /dev/null
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs btrfs
+_supported_os Linux
+_require_command "$KILLALL_PROG" killall
+_require_scratch
+_require_btrfs_command dedupe
+_require_btrfs_fs_feature dedupe
+
+# Use 64K dedupe size to keep compatibility for 64K page size
+dedupe_bs=64K
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+
+mkdir -p $SCRATCH_MNT/stressdir
+
+runtime=$((60 * $TIME_FACTOR))
+
+trigger_work()
+{
+ while true; do
+ _run_btrfs_util_prog dedupe enable -s inmemory \
+ -b $dedupe_bs $SCRATCH_MNT
+ sleep 1
+ _run_btrfs_util_prog dedupe disable $SCRATCH_MNT
+ sleep 1
+ done
+}
+
+# redirect all output, as error output like 'balance cancelled by user'
+# will populuate the golden output.
+_btrfs_stress_balance -m $SCRATCH_MNT &> /dev/null &
+balance_pid=$!
+
+$FSSTRESS_PROG $(_scale_fsstress_args -p 1 -n 10000000) $FSSTRESS_AVOID \
+ -d $SCRATCH_MNT/stressdir > /dev/null 2>&1 &
+
+trigger_work &
+trigger_pid=$!
+
+sleep $runtime
+$KILLALL_PROG $FSSTRESS_PROG &> /dev/null
+kill $trigger_pid &> /dev/null
+kill $balance_pid &> /dev/null
+wait
+
+# Manually stop balance as it's possible balance is still running for a short
+# time. And we don't want to populate $seqres.full, so call $BTRFS_UTIL_PROG
+# directly
+$BTRFS_UTIL_PROG balance cancel $SCRATCH_MNT &> /dev/null
+
+echo "Silence is golden"
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/201.out b/tests/btrfs/201.out
new file mode 100644
index 0000000..5ac973f
--- /dev/null
+++ b/tests/btrfs/201.out
@@ -0,0 +1,2 @@
+QA output created by 201
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 4e49564..1856d7e 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -142,3 +142,4 @@
137 auto quick send
138 auto compress
200 auto ib-dedupe
+201 auto ib-dedupe
--
2.9.3
^ permalink raw reply related [flat|nested] 9+ messages in thread* [PATCH v2 3/3] fstests: btrfs: Test inband dedupe with data balance.
2017-03-16 9:08 [PATCH v2 0/3] Btrfs in-band de-duplication test cases Qu Wenruo
2017-03-16 9:08 ` [PATCH v2 1/3] fstests: btrfs: Add basic test for btrfs in-band de-duplication Qu Wenruo
2017-03-16 9:08 ` [PATCH v2 2/3] fstests: btrfs: Add testcase for btrfs dedupe and metadata balance race test Qu Wenruo
@ 2017-03-16 9:08 ` Qu Wenruo
2017-03-21 8:44 ` Eryu Guan
2017-03-21 4:51 ` [PATCH v2 0/3] Btrfs in-band de-duplication test cases Eryu Guan
3 siblings, 1 reply; 9+ messages in thread
From: Qu Wenruo @ 2017-03-16 9:08 UTC (permalink / raw)
To: linux-btrfs; +Cc: fstests
Btrfs balance will reloate date extent, but its hash is removed too late
at run_delayed_ref() time, which will cause extent ref increased
during balance, cause either find_data_references() gives WARN_ON()
or even run_delayed_refs() fails and cause transaction abort.
Add such concurrency test for inband dedupe and data balance.
Signed-off-by: Qu Wenruo <quwenruo@cn.fujitsu.com>
---
tests/btrfs/202 | 109 ++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/btrfs/202.out | 3 ++
tests/btrfs/group | 1 +
3 files changed, 113 insertions(+)
create mode 100755 tests/btrfs/202
create mode 100644 tests/btrfs/202.out
diff --git a/tests/btrfs/202 b/tests/btrfs/202
new file mode 100755
index 0000000..60bb924
--- /dev/null
+++ b/tests/btrfs/202
@@ -0,0 +1,109 @@
+#! /bin/bash
+# FS QA Test 203
+#
+# Btrfs inband dedupe with balance concurrency test
+#
+# This can spot inband dedupe error which will increase delayed ref on
+# an data extent inside RO block group
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Fujitsu. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ kill $populate_pid &> /dev/null
+ kill $balance_pid &> /dev/null
+ wait
+ # Check later comment for reason
+ $BTRFS_UTIL_PROG balance cancel $SCRATCH_MNT &> /dev/null
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/reflink
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+_require_cp_reflink
+_require_btrfs_command dedupe
+_require_btrfs_fs_feature dedupe
+
+dedupe_bs=128k
+file_size_in_kilo=4096
+init_file=$SCRATCH_MNT/foo
+run_time=$((60 * $TIME_FACTOR))
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+
+do_dedupe_balance_test()
+{
+ _run_btrfs_util_prog dedupe enable -b $dedupe_bs -s inmemory $SCRATCH_MNT
+
+ # create the initial file and fill hash pool
+ $XFS_IO_PROG -f -c "pwrite -S 0x0 -b $dedupe_bs 0 $dedupe_bs" -c "fsync" \
+ $init_file | _filter_xfs_io
+
+ _btrfs_stress_balance $SCRATCH_MNT >/dev/null 2>&1 &
+ balance_pid=$!
+
+ # Populate fs with all 0 data, to trigger enough in-band dedupe work
+ # to race with balance
+ _populate_fs -n 5 -f 10000000 -d 1 -r $SCRATCH_MNT \
+ -s $file_size_in_kilo &> /dev/null &
+ populate_pid=$!
+
+ sleep $run_time
+
+ kill $populate_pid
+ kill $balance_pid
+ wait
+
+ # Sometimes even we killed $balance_pid and wait returned,
+ # balance may still be running, use balance cancel to wait it.
+ # As this is just a workaround, we don't want it pollute seqres
+ # so call $BTRFS_UTIL_PROG directly
+ $BTRFS_UTIL_PROG balance cancel $SCRATCH_MNT &> /dev/null
+
+ rm $SCRATCH_MNT/* -rf &> /dev/null
+ _run_btrfs_util_prog dedupe disable $SCRATCH_MNT
+}
+
+do_dedupe_balance_test
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/202.out b/tests/btrfs/202.out
new file mode 100644
index 0000000..ce03aa7
--- /dev/null
+++ b/tests/btrfs/202.out
@@ -0,0 +1,3 @@
+QA output created by 202
+wrote 131072/131072 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 1856d7e..930057a 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -143,3 +143,4 @@
138 auto compress
200 auto ib-dedupe
201 auto ib-dedupe
+202 auto ib-dedupe balance
--
2.9.3
^ permalink raw reply related [flat|nested] 9+ messages in thread* Re: [PATCH v2 3/3] fstests: btrfs: Test inband dedupe with data balance.
2017-03-16 9:08 ` [PATCH v2 3/3] fstests: btrfs: Test inband dedupe with data balance Qu Wenruo
@ 2017-03-21 8:44 ` Eryu Guan
0 siblings, 0 replies; 9+ messages in thread
From: Eryu Guan @ 2017-03-21 8:44 UTC (permalink / raw)
To: Qu Wenruo; +Cc: linux-btrfs, fstests
On Thu, Mar 16, 2017 at 05:08:51PM +0800, Qu Wenruo wrote:
> Btrfs balance will reloate date extent, but its hash is removed too late
^^^^^^^ relocate
> at run_delayed_ref() time, which will cause extent ref increased
> during balance, cause either find_data_references() gives WARN_ON()
> or even run_delayed_refs() fails and cause transaction abort.
>
> Add such concurrency test for inband dedupe and data balance.
>
> Signed-off-by: Qu Wenruo <quwenruo@cn.fujitsu.com>
> ---
> tests/btrfs/202 | 109 ++++++++++++++++++++++++++++++++++++++++++++++++++++
> tests/btrfs/202.out | 3 ++
> tests/btrfs/group | 1 +
> 3 files changed, 113 insertions(+)
> create mode 100755 tests/btrfs/202
> create mode 100644 tests/btrfs/202.out
>
> diff --git a/tests/btrfs/202 b/tests/btrfs/202
> new file mode 100755
> index 0000000..60bb924
> --- /dev/null
> +++ b/tests/btrfs/202
> @@ -0,0 +1,109 @@
> +#! /bin/bash
> +# FS QA Test 203
> +#
> +# Btrfs inband dedupe with balance concurrency test
> +#
> +# This can spot inband dedupe error which will increase delayed ref on
> +# an data extent inside RO block group
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2017 Fujitsu. All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1 # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> + cd /
> + kill $populate_pid &> /dev/null
> + kill $balance_pid &> /dev/null
> + wait
> + # Check later comment for reason
> + $BTRFS_UTIL_PROG balance cancel $SCRATCH_MNT &> /dev/null
> + rm -f $tmp.*
I sometimes saw "btrfs balance start" hold $SCRATCH_MNT from umounting
and result in fs inconsistency after test. Some debug codes show that
the "btrfs balance start $SCRATCH_MNT" is still running. If I add what
btrfs/061 does:
while ps aux | grep "balance start" | grep -qv grep; do
sleep 1
done
test finishes fine. But btrfs-balance(8) says balance cancel should
block and wait for the backgroud balance process to finish. Seems like a
"balance cancel" bug?
Otherwise these three patches look fine to me overall, except the wanted
"dedupe feature check", and btrfs/200 is quick enough to fit in 'quick'
group.
I think the "dedupe feature check" should _notrun the tests if current
btrfs has incompatible features set, e.g. compress and/or nodatacow.
Thanks,
Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at https://urldefense.proofpoint.com/v2/url?u=http-3A__vger.kernel.org_majordomo-2Dinfo.html&d=DwIBAg&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=nWE-jTyw1r30et0l_N3AaUr-ObwCVWjbke3PEOdNLCM&s=hZq9UUBzZ-MIMAICK1qbDimaNfIbO4S-cmSSyc8OsfA&e=
^ permalink raw reply [flat|nested] 9+ messages in thread
* Re: [PATCH v2 0/3] Btrfs in-band de-duplication test cases
2017-03-16 9:08 [PATCH v2 0/3] Btrfs in-band de-duplication test cases Qu Wenruo
` (2 preceding siblings ...)
2017-03-16 9:08 ` [PATCH v2 3/3] fstests: btrfs: Test inband dedupe with data balance Qu Wenruo
@ 2017-03-21 4:51 ` Eryu Guan
2017-03-21 5:22 ` Qu Wenruo
3 siblings, 1 reply; 9+ messages in thread
From: Eryu Guan @ 2017-03-21 4:51 UTC (permalink / raw)
To: Qu Wenruo; +Cc: linux-btrfs, fstests
Hi Qu,
On Thu, Mar 16, 2017 at 05:08:48PM +0800, Qu Wenruo wrote:
> Btrfs in-band de-duplication test cases for in-memory backend, which covers
> the bugs exposed during the development.
Do you have a kernel tree that contains the in-band patches so that I
and others could try and run these tests?
Thanks,
Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at https://urldefense.proofpoint.com/v2/url?u=http-3A__vger.kernel.org_majordomo-2Dinfo.html&d=DwIBAg&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=VUc3e14G_mnZYV8O2gYkblZFxQSIOM_mXh6s3iwvOcc&s=0oOvhsrrGuZEAp3EVyph1XPboLmrUcRy0uEWz-Qbaf8&e=
^ permalink raw reply [flat|nested] 9+ messages in thread* Re: [PATCH v2 0/3] Btrfs in-band de-duplication test cases
2017-03-21 4:51 ` [PATCH v2 0/3] Btrfs in-band de-duplication test cases Eryu Guan
@ 2017-03-21 5:22 ` Qu Wenruo
2017-03-21 6:05 ` Eryu Guan
0 siblings, 1 reply; 9+ messages in thread
From: Qu Wenruo @ 2017-03-21 5:22 UTC (permalink / raw)
To: Eryu Guan; +Cc: linux-btrfs, fstests
At 03/21/2017 12:51 PM, Eryu Guan wrote:
> Hi Qu,
>
> On Thu, Mar 16, 2017 at 05:08:48PM +0800, Qu Wenruo wrote:
>> Btrfs in-band de-duplication test cases for in-memory backend, which covers
>> the bugs exposed during the development.
>
> Do you have a kernel tree that contains the in-band patches so that I
> and others could try and run these tests?
Of course.
Kernel tree:
https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_linux.git&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=LH-PUN-NTCIEZi5d2XrvY6_JhnYPAgEaDvMo9hTzFyM&s=F2xbdCcGvb6crFhEcUtBrCPE8eGjCODlytD8HoBFOlA&e= wang_dedupe_latest
Btrfs-progs tree:
https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_btrfs-2Dprogs.git&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=LH-PUN-NTCIEZi5d2XrvY6_JhnYPAgEaDvMo9hTzFyM&s=O4LlYyQ_nT0wBVzWYlxn0aGYMO2SnljTsb1kxAoSifs&e= dedupe_20170306
Thanks,
Qu
>
> Thanks,
> Eryu
>
>
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at https://urldefense.proofpoint.com/v2/url?u=http-3A__vger.kernel.org_majordomo-2Dinfo.html&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=LH-PUN-NTCIEZi5d2XrvY6_JhnYPAgEaDvMo9hTzFyM&s=6szMktjYq6NMzo2R_IXGJkr1ABOyl7lW7zpeh8TRYmk&e=
^ permalink raw reply [flat|nested] 9+ messages in thread
* Re: [PATCH v2 0/3] Btrfs in-band de-duplication test cases
2017-03-21 5:22 ` Qu Wenruo
@ 2017-03-21 6:05 ` Eryu Guan
2017-03-21 7:07 ` Qu Wenruo
0 siblings, 1 reply; 9+ messages in thread
From: Eryu Guan @ 2017-03-21 6:05 UTC (permalink / raw)
To: Qu Wenruo; +Cc: linux-btrfs, fstests
On Tue, Mar 21, 2017 at 01:22:33PM +0800, Qu Wenruo wrote:
>
>
> At 03/21/2017 12:51 PM, Eryu Guan wrote:
> > Hi Qu,
> >
> > On Thu, Mar 16, 2017 at 05:08:48PM +0800, Qu Wenruo wrote:
> > > Btrfs in-band de-duplication test cases for in-memory backend, which covers
> > > the bugs exposed during the development.
> >
> > Do you have a kernel tree that contains the in-band patches so that I
> > and others could try and run these tests?
>
> Of course.
>
> Kernel tree:
> https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_linux.git&d=DwIBAg&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=YzsA7J_jQbbCdcg4s_RD-fVgAB-E0z9HI7TsNs0ISJ8&s=3WywXrgANPtqSESgw9Ey4wt8D3niq7n9yhn2W_lat1c&e= wang_dedupe_latest
>
> Btrfs-progs tree:
> https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_btrfs-2Dprogs.git&d=DwIBAg&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=YzsA7J_jQbbCdcg4s_RD-fVgAB-E0z9HI7TsNs0ISJ8&s=8wuw_b8hI8oTVNrb2E_N0mqv8jzV8svYD6gcotli0eY&e= dedupe_20170306
Thanks! But I guess it's branch 'dedupe_20170316' of btrfs-progs repo,
right? There's no dedupe_20170306 branch.
Thanks,
Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at https://urldefense.proofpoint.com/v2/url?u=http-3A__vger.kernel.org_majordomo-2Dinfo.html&d=DwIBAg&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=YzsA7J_jQbbCdcg4s_RD-fVgAB-E0z9HI7TsNs0ISJ8&s=r92jDqcAqEQ6yzfk0gRIezOrZmWu-Nm5X5Rdo7mS0rM&e=
^ permalink raw reply [flat|nested] 9+ messages in thread
* Re: [PATCH v2 0/3] Btrfs in-band de-duplication test cases
2017-03-21 6:05 ` Eryu Guan
@ 2017-03-21 7:07 ` Qu Wenruo
0 siblings, 0 replies; 9+ messages in thread
From: Qu Wenruo @ 2017-03-21 7:07 UTC (permalink / raw)
To: Eryu Guan; +Cc: linux-btrfs, fstests
At 03/21/2017 02:05 PM, Eryu Guan wrote:
> On Tue, Mar 21, 2017 at 01:22:33PM +0800, Qu Wenruo wrote:
>>
>>
>> At 03/21/2017 12:51 PM, Eryu Guan wrote:
>>> Hi Qu,
>>>
>>> On Thu, Mar 16, 2017 at 05:08:48PM +0800, Qu Wenruo wrote:
>>>> Btrfs in-band de-duplication test cases for in-memory backend, which covers
>>>> the bugs exposed during the development.
>>>
>>> Do you have a kernel tree that contains the in-band patches so that I
>>> and others could try and run these tests?
>>
>> Of course.
>>
>> Kernel tree:
>> https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_linux.git&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=AlaxqQ2gCXL8UWQhFiLoFihaFpJdE8sGyYio_4BPHXc&s=BOoKfXNsZz1NblwdqyaExc-i8GlnniYtHqefZgia1Tk&e= wang_dedupe_latest
>>
>> Btrfs-progs tree:
>> https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_adam900710_btrfs-2Dprogs.git&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=AlaxqQ2gCXL8UWQhFiLoFihaFpJdE8sGyYio_4BPHXc&s=nBDSWd-5rMCPT5a8aD8LNst5myNIhyN6pFNENVS-wtU&e= dedupe_20170306
>
> Thanks! But I guess it's branch 'dedupe_20170316' of btrfs-progs repo,
> right? There's no dedupe_20170306 branch.
My fault, it's 20170316.
Thanks,
Qu
>
> Thanks,
> Eryu
>
>
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at https://urldefense.proofpoint.com/v2/url?u=http-3A__vger.kernel.org_majordomo-2Dinfo.html&d=DwICaQ&c=RoP1YumCXCgaWHvlZYR8PQcxBKCX5YTpkKY057SbK10&r=-yMrTV4jriXR7ieyzzjV-QgHBD0UDw8ixoR77aMeAHE&m=AlaxqQ2gCXL8UWQhFiLoFihaFpJdE8sGyYio_4BPHXc&s=nLAzqwoOOI-rQs7lY4oocN0_46-pabkIcKHcXgAA4Vs&e=
^ permalink raw reply [flat|nested] 9+ messages in thread